package com.offcn.api.tk.app3;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.util.HashMap;
import java.util.Map;

import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.TK;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;




/**
 * 
 * @Description:   用户反馈
 * @author:lyy    
 * @date: 
 * @version V1.0
 */
public class userFeedback extends TK implements API {
	public String parameter;//参数集合
	
	public String image_id;//由搜题接口返回的图片id  （32位）
	public String user_id;//用户id
	public String question_id;//试题id
	public String feedback;//用户反馈内容 1:满意  0 不满意


	@Override
	public void initialize(HashMap<String, Object> data) {
		if (!isProduct && data.get("CleanDB").toString().contains("Y")) {
			cleanUser_FromDB();//清除注册用户根据user_id
		}
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		image_id = MapUtil.getParameter(parameter, "image_id").trim();
		user_id = MapUtil.getParameter(parameter, "user_id").trim();
		question_id = MapUtil.getParameter(parameter, "question_id").trim();
		feedback = MapUtil.getParameter(parameter, "feedback").trim();
	
		
		if ((!user_id.equals("")) && user_id.equals("code")) {
			user_id=ListUtil.getListValue(user_idList,0);
			parameter = parameter.replace("\"user_id\":code", "\"user_id\":\""+ user_id + "\"");
		}
		
		if ((!question_id.equals("")) && question_id.equals("code")) {
			question_id = question_id;
//			exam_id = "1";
			parameter = parameter.replace("\"question_id\":code", "\"question_id\":\""+ question_id + "\"");
		}
		if ((!image_id.equals("")) && image_id.equals("code")) {
			image_id = image_id;
//			origin_id = "1";
			parameter = parameter.replace("\"image_id\":code", "\"image_id\":\""+ image_id + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String, String> headers=new HashMap<String, String>();
		headers.put("Authorization", tk_token);
		Map<String, String> jsonString=new HashMap<String, String>();
		jsonString.put("user_id", user_id);
		jsonString.put("image_id", image_id);
		jsonString.put("question_id", question_id);
		jsonString.put("feedback", feedback);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setHeaders(headers);
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setFormParameter(jsonString);
		
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		
		//Response re = RequestDataUtils.Post_token(data, Url,tk_token);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = StringUtils.decodeUnicode(re.asString());

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			if("0".equals(code)){
				
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
